typedef struct {
   Word renamedCategories;
   Char    categoryLabels [dmRecNumCategories] [dmCategoryLength];
   Byte    categoryUniqIDs[dmRecNumCategories];
   Byte    lastUniqID;     // Uniq IDs generated by the device are between
                           // 0 - 127.  Those from the PC are 128 - 255.
} AppInfoType;

typedef AppInfoType * AppInfoPtr;



void CategoryCreateListV10 (DmOpenRef db, ListPtr lst,
                            Word currentCategory, Boolean showAll)
     SYS_TRAP(sysTrapCategoryCreateListV10);

void CategoryCreateList (DmOpenRef db, ListPtr listP,
                         Word currentCategory, Boolean showAll,
                         Boolean showUneditables, Byte numUneditableCategories,
                         DWord editingStrID, Boolean resizeList)
     SYS_TRAP(sysTrapCategoryCreateList);


void CategoryFreeListV10 (DmOpenRef db, ListPtr lst)
     SYS_TRAP(sysTrapCategoryFreeListV10);

void CategoryFreeList (DmOpenRef db, ListPtr listP,
                       Boolean showAll, DWord editingStrID)
     SYS_TRAP(sysTrapCategoryFreeList);

Word CategoryFind (DmOpenRef db, CharPtr name)
     SYS_TRAP(sysTrapCategoryFind);

void CategoryGetName (DmOpenRef db, Word index, CharPtr name)
     SYS_TRAP(sysTrapCategoryGetName);

Boolean CategoryEditV10 (DmOpenRef db, WordPtr category)
        SYS_TRAP(sysTrapCategoryEditV10);

Boolean CategoryEdit (DmOpenRef db, WordPtr category, DWord titleStrID)
        SYS_TRAP(sysTrapCategoryEdit);

Boolean CategorySelectV10 (DmOpenRef db, FormPtr frm, Word ctlID,
                           Word lstID, Boolean title, WordPtr categoryP, CharPtr categoryName)
        SYS_TRAP(sysTrapCategorySelectV10);

Boolean CategorySelect (DmOpenRef db, FormPtr frm, Word ctlID,
                        Word lstID, Boolean title, WordPtr categoryP, CharPtr categoryName,
                        Byte numUneditableCategories, DWord editingStrID)
        SYS_TRAP(sysTrapCategorySelect);

Word CategoryGetNext (DmOpenRef db, Word index)
     SYS_TRAP(sysTrapCategoryGetNext);

void CategorySetTriggerLabel (ControlPtr ctl, CharPtr name)
     SYS_TRAP(sysTrapCategorySetTriggerLabel);

void CategoryTruncateName (CharPtr name, Word maxWidth)
     SYS_TRAP(sysTrapCategoryTruncateName);

void CategoryInitialize (AppInfoPtr appInfoP, Word localizedAppInfoStrID)
     SYS_TRAP(sysTrapCategoryInitialize);

void CategorySetName (DmOpenRef db, Word index, CharPtr nameP)
     SYS_TRAP(sysTrapCategorySetName);
