typedef struct {
  Byte usable      :1;  // set if part of ui
  Byte enabled     :1;  // set if interactable (not grayed out)
  Byte visible     :1;  // set if drawn (set internally)
  Byte on          :1;  // set if on (checked)
  Byte leftAnchor  :1;  // set if bounds expand to the right
                        // clear if bounds expand to the left
  Byte frame       :3;
} ControlAttrType;


enum controlStyles {buttonCtl, pushButtonCtl, checkboxCtl, popupTriggerCtl,
                                                         selectorTriggerCtl, repeatingButtonCtl};
typedef enum controlStyles ControlStyleType;

enum buttonFrames {noButtonFrame, standardButtonFrame, boldButtonFrame,
                                                 rectangleButtonFrame};
typedef enum buttonFrames ButtonFrameType;


typedef struct {
  Word             id;
  RectangleType    bounds;
  CharPtr          text;
  ControlAttrType  attr;
  ControlStyleType style;
  FontID           font;
  Byte             group;
} ControlType;


typedef ControlType * ControlPtr;



//----------------------------------------------------------
//      Control Functions
//----------------------------------------------------------

void CtlDrawControl (ControlPtr pControl)
     SYS_TRAP(sysTrapCtlDrawControl);

void CtlEraseControl (ControlPtr pControl)
     SYS_TRAP(sysTrapCtlEraseControl);

void CtlHideControl (ControlPtr pControl)
     SYS_TRAP(sysTrapCtlHideControl);

void CtlShowControl (ControlPtr pControl)
     SYS_TRAP(sysTrapCtlShowControl);

Boolean CtlEnabled (ControlPtr pControl)
        SYS_TRAP(sysTrapCtlEnabled);

void CtlSetEnabled (ControlPtr pControl, Boolean usable)
     SYS_TRAP(sysTrapCtlSetEnabled);

void CtlSetUsable (ControlPtr pControl, Boolean usable)
     SYS_TRAP(sysTrapCtlSetUsable);

SWord CtlGetValue (ControlPtr pControl)
      SYS_TRAP(sysTrapCtlGetValue);

void CtlSetValue (ControlPtr pControl, SWord newValue)
     SYS_TRAP(sysTrapCtlSetValue);

CharPtr CtlGetLabel (ControlPtr pControl)
        SYS_TRAP(sysTrapCtlGetLabel);

void CtlSetLabel (ControlPtr pControl, CharPtr newLabel)
     SYS_TRAP(sysTrapCtlSetLabel);

void CtlHitControl (ControlPtr pControl)
     SYS_TRAP(sysTrapCtlHitControl);

Boolean CtlHandleEvent (ControlPtr pControl, EventPtr pEvent)
        SYS_TRAP(sysTrapCtlHandleEvent);
