typedef struct
{
  SByte offset;
  SByte width;
} FontCharInfoType;

typedef struct{
  SWord fontType;    // font type
  SWord firstChar;   // ASCII code of first character
  SWord lastChar;    // ASCII code of last character
  SWord maxWidth;    // maximum character width
  SWord kernMax;     // negative of maximum character kern
  SWord nDescent;    // negative of descent
  SWord fRectWidth;  // width of font rectangle
  SWord fRectHeight; // height of font rectangle
  SWord owTLoc;      // offset to offset/width table
  SWord ascent;      // ascent
  SWord descent;     // descent
  SWord leading;     // leading
  SWord rowWords;    // row width of bit image / 2
} FontType;

typedef FontType * FontPtr;

enum fontID { stdFont, boldFont, largeFont, symbolFont, symbol11Font,
                                  symbol7Font, ledFont };

#define checkboxFont symbol11Font


typedef enum fontID FontID;


//--------------------------------------------------------------------
//
// Font Function
//
//--------------------------------------------------------------------

FontID FntGetFont (void)
       SYS_TRAP(sysTrapFntGetFont);

FontID FntSetFont (FontID font)
       SYS_TRAP(sysTrapFntSetFont);

FontPtr FntGetFontPtr (void)
        SYS_TRAP(sysTrapFntGetFontPtr);

SWord FntBaseLine (void)
      SYS_TRAP(sysTrapFntBaseLine);

SWord FntCharHeight (void)
      SYS_TRAP(sysTrapFntCharHeight);

SWord FntLineHeight (void)
      SYS_TRAP(sysTrapFntLineHeight);

SWord FntAverageCharWidth (void)
      SYS_TRAP(sysTrapFntAverageCharWidth);

SWord FntCharWidth (Char ch)
      SYS_TRAP(sysTrapFntCharWidth);

SWord FntCharsWidth (Char *chars, Word len)
      SYS_TRAP(sysTrapFntCharsWidth);

void FntCharsInWidth(CharPtr string, SWord *stringWidthP,
                     SWord *stringLengthP, Boolean *fitWithinWidth)
     SYS_TRAP(sysTrapFntCharsInWidth);

SWord FntDescenderHeight (void)
      SYS_TRAP(sysTrapFntDescenderHeight);

SWord FntLineWidth (CharPtr pChars, Word length)
      SYS_TRAP(sysTrapFntLineWidth);

Word FntWordWrap (CharPtr chars, Word maxWidth)
     SYS_TRAP(sysTrapFntWordWrap);

void FntWordWrapReverseNLines (CharPtr chars, Word maxWidth,
                               WordPtr linesToScrollP, WordPtr scrollPosP)
     SYS_TRAP(sysTrapFntWordWrapReverseNLines);

void FntGetScrollValues (CharPtr chars, Word width, Word scrollPos,
                         WordPtr linesP, WordPtr topLine)
     SYS_TRAP(sysTrapFntGetScrollValues);
